## elvish 0.10.1

=== Makefile ===
PKG_BASE := github.com/elves/elvish
PKGS := $(shell go list ./... | grep -v /vendor/)
PKG_COVERS := $(shell go list ./... | grep -v '^$(PKG_BASE)/vendor/' | grep -v '^$(PKG_BASE)$$' | sed "s|^$(PKG_BASE)/|cover/|" | sed 's/$$/.cover/')
COVER_MODE := set

FIRST_GOPATH=$(shell go env GOPATH | cut -d: -f1)

default: get test

get:
	go get .

generate:
	go generate ./...

test:
	go test $(PKGS)

cover/%.cover: %
	mkdir -p $(dir $@)
	go test -coverprofile=$@ -covermode=$(COVER_MODE) ./$<

cover/all: $(PKG_COVERS)
	echo mode: $(COVER_MODE) > $@
	for f in $(PKG_COVERS); do test -f $$f && sed 1d $$f >> $@ || true; done

# We would love to test for coverage in pull requests, but it's now
# bettered turned off for two reasons:
#
# 1) The goverall badge will always show the "latest" coverage, even if that
# comes from a PR.
#
# 2) Some of the tests have fluctuating coverage (the test against
# edit.tty.AsyncReader), and goveralls will put a big cross on the PR when the
# coverage happens to drop.
goveralls: cover/all
	test "$(TRAVIS_PULL_REQUEST)" = false \
		&& go get -u github.com/mattn/goveralls \
		&& $(FIRST_GOPATH)/bin/goveralls -coverprofile=cover/all -service=travis-ci \
		|| echo "not sending to coveralls"

upload: get
	tar cfz elvish.tar.gz -C $(FIRST_GOPATH)/bin elvish
	echo "$(TRAVIS_GO_VERSION)" | grep -q '^1.8' \
		&& test "$(TRAVIS_PULL_REQUEST)" = false \
		&& test -n "$(TRAVIS_TAG)" -o "$(TRAVIS_BRANCH)" = master \
		&& curl http://ul.elvish.io:6060/ -F name=elvish-$(if $(TRAVIS_TAG),$(TRAVIS_TAG)-,)$(TRAVIS_OS_NAME).tar.gz \
			-F token=$$UPLOAD_TOKEN -F file=@./elvish.tar.gz\
		|| echo "not uploading"

travis: goveralls upload

.PHONY: default get generate test goveralls upload travis

=== debian/changelog ===
elvish (0.10.1-1) unstable; urgency=medium

  * New upstream version 0.10.1
  * Prefer gccgo-go on ppc64* and golang-any on others (Closes: #873889)
  * Bump golang-github-xiaq-persistent-dev to 0.0~git20170830.75c17f0

 -- Shengjing Zhu <i@zhsj.me>  Wed, 20 Sep 2017 14:34:12 +0800

elvish (0.9+git20170829.a2ab19c-1) unstable; urgency=medium

  * New upstream version 0.9+git20170829.a2ab19c
  * d/control
    + update Build-Depends, remove golang-github-mattn-go-sqlite3-dev
      add golang-github-boltdb-bolt-dev
    + update Standards-Versions to 4.1.0(no changes needed)
  * Remove all patches, not needed with new release

 -- Shengjing Zhu <i@zhsj.me>  Thu, 31 Aug 2017 15:57:19 +0800

elvish (0.9-1) unstable; urgency=medium

  * Initial release (Closes: #867524)

 -- Shengjing Zhu <i@zhsj.me>  Sun, 16 Jul 2017 22:25:36 +0800

=== debian/control ===
Source: elvish
Section: shells
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Shengjing Zhu <i@zhsj.me>,
Build-Depends: debhelper (>= 10),
               dh-golang,
               gccgo-go [ppc64el ppc64],
               golang-any [!ppc64el !ppc64],
               golang-github-boltdb-bolt-dev,
               golang-github-kr-pty-dev,
               golang-github-mattn-go-isatty-dev,
               golang-github-xiaq-persistent-dev (>=0.0~git20170830.75c17f0),
               golang-golang-x-sys-dev,
Standards-Version: 4.1.0
Homepage: https://github.com/elves/elvish
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/elvish.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/elvish.git
XS-Go-Import-Path: github.com/elves/elvish
Testsuite: autopkgtest-pkg-go

Package: elvish
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Friendly and expressive Unix shell
 Elvish is a cross-platform shell suitable for both interactive
 use and scripting. It features a full-fledged, non-POSIX-shell
 programming language with advanced features like namespacing
 and anonymous functions, and a powerful, fully programmable user
 interface that works well out of the box.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%elvish-$1.tar.gz%" \
  https://github.com/elves/elvish/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## elvish 0.11+ds1

=== Makefile ===
PKG_BASE := github.com/elves/elvish
PKGS := $(shell go list ./... | sed 's|^$(PKG_BASE)|.|' | grep -v '^./vendor')
PKG_COVERS := $(shell go list ./... | sed 's|^$(PKG_BASE)|.|' | grep -v '^\./vendor' | grep -v '^\.$$' | sed 's/^\./cover/' | sed 's/$$/.cover/')
COVER_MODE := set
VERSION := $(shell git describe --tags --always)

GOVERALLS := github.com/mattn/goveralls

default: test get

get:
	go get -ldflags "-X github.com/elves/elvish/build.Version=$(VERSION) -X github.com/elves/elvish/build.Builder=$(shell id -un)@$(shell hostname)" .

generate:
	go generate ./...

test:
	go test $(PKGS)

testmain:
	go test .

cover/%.cover: %
	mkdir -p $(dir $@)
	go test -coverprofile=$@ -covermode=$(COVER_MODE) ./$<

cover/all: $(PKG_COVERS)
	echo mode: $(COVER_MODE) > $@
	for f in $(PKG_COVERS); do test -f $$f && sed 1d $$f >> $@ || true; done

# Disable coverage reports for pull requests. The general testability of the
# code is pretty bad and it is premature to require contributors to maintain
# code coverage.
upload-codecov-travis: cover/all
	test "$(TRAVIS_PULL_REQUEST)" = false \
		&& echo "$(TRAVIS_GO_VERSION)" | grep -q '^1.9' \
		&& curl -s https://codecov.io/bash -o codecov.bash \
		&& bash codecov.bash -f $< \
		|| echo "not sending to codecov.io"

upload-coveralls-travis: cover/all
	test "$(TRAVIS_PULL_REQUEST)" = false \
		&& echo "$(TRAVIS_GO_VERSION)" | grep -q '^1.9' \
		&& go get -d $(GOVERALLS) \
		&& go build -o goveralls $(GOVERALLS) \
		&& ./goveralls -coverprofile $< -service=travis-ci \
		|| echo "not sending to coveralls.io"

upload-codecov-appveyor: cover/all
	test -z "$(APPVEYOR_PULL_REQUEST_NUMBER)" \
		&& codecov -f $< \
		|| echo "not sending to codecov.io"

upload-coveralls-appveyor: cover/all
	test -z "$(APPVEYOR_PULL_REQUEST_NUMBER)" \
		&& goveralls -coverprofile $< -service=appveyor-ci \
		|| echo "not sending to coveralls.io"

upload-bin:
	test "$(TRAVIS_OS_NAME)" = linux \
		&& echo "$(TRAVIS_GO_VERSION)" | grep -q '^1.9' \
		&& test "$(TRAVIS_PULL_REQUEST)" = false \
		&& test -n "$(TRAVIS_TAG)" -o "$(TRAVIS_BRANCH)" = master \
		&& go build -o ./elvish \
		&& ./elvish build-and-upload.elv \
		|| echo "not build-and-uploading"

travis: testmain upload-codecov-travis upload-coveralls-travis upload-bin
appveyor: testmain upload-codecov-appveyor

.PHONY: default get generate test testmain upload-codecov-travis upload-coveralls-travis upload-codecov-appveyor upload-coveralls-appveyor upload-bin travis

=== debian/changelog ===
elvish (0.11+ds1-3) unstable; urgency=medium

  * Team upload.
  * Vcs-* urls: pkg-go-team -> go-team.

 -- Alexandre Viau <aviau@debian.org>  Tue, 06 Feb 2018 00:30:12 -0500

elvish (0.11+ds1-2) unstable; urgency=medium

  * Team upload.
  * Point Vcs-* urls to salsa subgroup.

 -- Alexandre Viau <aviau@debian.org>  Thu, 25 Jan 2018 18:48:09 -0500

elvish (0.11+ds1-1) unstable; urgency=medium

  * New upstream version 0.11+ds1
  * d/control: remove golang-github-mattn-go-isatty-dev from Build-Depends
  * d/patches: remove 0001-fix-overflows-on-req-arg-in-ioctl.patch,
    applied in upstream

 -- Shengjing Zhu <i@zhsj.me>  Thu, 18 Jan 2018 10:06:02 +0800

elvish (0.11~rc1+ds1-2) experimental; urgency=medium

  * d/rules: pass build info to ldflags
  * Update man page
  * d/control: update package description
  * d/control: update vcs url to salsa.d.o
  * d/patches: add 0001-fix-overflows-on-req-arg-in-ioctl.patch
    to fix building on mips

 -- Shengjing Zhu <i@zhsj.me>  Tue, 16 Jan 2018 13:08:07 +0800

elvish (0.11~rc1+ds1-1) experimental; urgency=medium

  * New upstream version 0.11~rc1+ds1
  * d/watch: add repacksuffix and uversionmangle for rc version
  * d/rule: remove mips build hack
  * Update compat and debhelper version to 11
  * d/control: update Build-Depends
  * d/control: update Standards-Version to 4.1.3(no changes)
  * d/copyright: update go-termios authors' file list

 -- Shengjing Zhu <i@zhsj.me>  Tue, 16 Jan 2018 01:28:01 +0800

elvish (0.10.1-2) unstable; urgency=medium

  * workaround to build on mips
  * d/control: update Standards-Version to 4.1.1(no changes)

 -- Shengjing Zhu <i@zhsj.me>  Thu, 05 Oct 2017 01:21:59 +0800

=== debian/control ===
Source: elvish
Section: shells
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Shengjing Zhu <i@zhsj.me>,
Build-Depends: debhelper (>= 11),
               dh-golang,
               gccgo-go [ppc64el ppc64],
               golang-any [!ppc64el !ppc64],
               golang-github-boltdb-bolt-dev,
               golang-github-kr-pty-dev,
               golang-github-xiaq-persistent-dev (>=0.0~git20180105.221501f),
               golang-golang-x-sys-dev,
Standards-Version: 4.1.3
Homepage: https://github.com/elves/elvish
Vcs-Browser: https://salsa.debian.org/go-team/packages/elvish
Vcs-Git: https://salsa.debian.org/go-team/packages/elvish.git
XS-Go-Import-Path: github.com/elves/elvish
Testsuite: autopkgtest-pkg-go

Package: elvish
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Friendly and expressive shell
 Elvish is a cross-platform shell, supporting Linux, BSDs and Windows.
 It features an expressive programming language, with features like namespacing
 and anonymous functions, and a fully programmable user interface with friendly
 defaults. It is suitable for both interactive use and scripting.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

BUILDER    := $(shell sed -ne 's,^Maintainer: .[^<]*<\([^>]*\)>,\1,p' debian/control)
BUILDPKG   := github.com/elves/elvish/build
BUILDFLAGS := -ldflags\
  "-X $(BUILDPKG).Version=$(DEB_VERSION)\
   -X $(BUILDPKG).Builder=$(BUILDER)"

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)

override_dh_auto_install:
	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts="uversionmangle=s/v?(\d[\d.]*)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/, \
      dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/elves/elvish/tags \
  .*/(.*)\.tar\.gz

## elvish 0.12+ds1

=== Makefile ===
PKG_BASE := github.com/elves/elvish
PKGS := $(shell go list ./... | sed 's|^$(PKG_BASE)|.|' | grep -v '^./\(vendor\|website\)')
PKG_COVERS := $(shell go list ./... | sed 's|^$(PKG_BASE)|.|' | grep -v '^\./\(vendor\|website\)' | grep -v '^\.$$' | sed 's/^\./cover/' | sed 's/$$/.cover/')
COVER_MODE := set
VERSION := $(shell git describe --tags --always --dirty=-dirty)

GOVERALLS := github.com/mattn/goveralls

default: test get

get:
	go get -ldflags "-X github.com/elves/elvish/buildinfo.Version=$(VERSION) \
		-X github.com/elves/elvish/buildinfo.GoRoot=$(shell go env GOROOT) \
		-X github.com/elves/elvish/buildinfo.GoPath=$(shell go env GOPATH)" .

buildall:
	./buildall.sh

generate:
	go generate ./...

test:
	go test $(PKGS)

testmain:
	go test .

cover/%.cover: %
	mkdir -p $(dir $@)
	go test -coverprofile=$@ -covermode=$(COVER_MODE) ./$<

cover/all: $(PKG_COVERS)
	echo mode: $(COVER_MODE) > $@
	for f in $(PKG_COVERS); do test -f $$f && sed 1d $$f >> $@ || true; done

# Disable coverage reports for pull requests. The general testability of the
# code is pretty bad and it is premature to require contributors to maintain
# code coverage.
upload-codecov-travis: cover/all
	test "$(TRAVIS_PULL_REQUEST)" = false \
		&& echo "$(TRAVIS_GO_VERSION)" | grep -q '^1.10' \
		&& curl -s https://codecov.io/bash -o codecov.bash \
		&& bash codecov.bash -f $< \
		|| echo "not sending to codecov.io"

upload-coveralls-travis: cover/all
	test "$(TRAVIS_PULL_REQUEST)" = false \
		&& echo "$(TRAVIS_GO_VERSION)" | grep -q '^1.10' \
		&& go get -d $(GOVERALLS) \
		&& go build -o goveralls $(GOVERALLS) \
		&& ./goveralls -coverprofile $< -service=travis-ci \
		|| echo "not sending to coveralls.io"

upload-codecov-appveyor: cover/all
	test -z "$(APPVEYOR_PULL_REQUEST_NUMBER)" \
		&& codecov -f $< \
		|| echo "not sending to codecov.io"

upload-coveralls-appveyor: cover/all
	test -z "$(APPVEYOR_PULL_REQUEST_NUMBER)" \
		&& goveralls -coverprofile $< -service=appveyor-ci \
		|| echo "not sending to coveralls.io"

travis: testmain upload-codecov-travis upload-coveralls-travis
appveyor: testmain upload-codecov-appveyor

.PHONY: default get buildall generate test testmain upload-codecov-travis upload-coveralls-travis upload-codecov-appveyor upload-coveralls-appveyor travis

=== website/Makefile ===
PUBLISH_DIR := ./publish

MDS := $(wildcard src/*.md src/*/*.md)
HTMLS := $(MDS:.md=.html)

TOOL_SOURCES := $(wildcard *.go)
TOOL_BINARIES := $(TOOL_SOURCES:.go=.tool)

default: gen

%.html: %.md $(TOOL_BINARIES) md-to-html
	./md-to-html $< $@

%.tool: %.go
	go build -o $@ $<

# Generates the website into the dst directory.
gen: $(HTMLS) maybe-genblog
	genblog src dst
	ln -sf `pwd`/assets dst/
	ln -sf `pwd`/favicons/* dst/

# Installs genblog only if not found.
maybe-genblog:
	which genblog || make genblog

# Installs latest genblog.
genblog:
	go get -u github.com/xiaq/genblog
	genblog -print-default-css > assets/genblog.css

# Copies the generated website into $(PUBLISH_DIR).
publish: gen
	rsync -aLv --delete ./dst/ $(PUBLISH_DIR)/

clean:
	rm -f $(HTMLS) $(TOOL_BINARIES)

.PHONY: default gen maybe-genblog genblog publish clean
.SECONDARY: $(TOOL_BINARIES)

=== debian/changelog ===
elvish (0.12+ds1-2) unstable; urgency=medium

  * Fix uscan version mangle
  * Update pkg-go team and my email address

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 09 Feb 2019 00:53:55 +0800

elvish (0.12+ds1-1) unstable; urgency=medium

  * New upstream version 0.12+ds1
  * d/rules: make DATE reproducible
  * d/rules: s/markdown_github/gfm in pandoc arg

 -- Shengjing Zhu <i@zhsj.me>  Wed, 11 Jul 2018 10:37:51 +0800

elvish (0.12~rc1+ds1-1) experimental; urgency=medium

  * New upstream version 0.12~rc1+ds1
  * d/control: update Standards-Version to 4.1.4 (no changes)
  * d/patches: drop merged patches
  * d/control: bump golang-github-xiaq-persistent-dev to 20180301
  * d/rules: update ldflags for buildinfo
  * d/rules: add website to DH_GOLANG_EXCLUDES
  * d/rules: disable editor e2e test
  * d/elvish.1: update manpage
  * Use pandoc to generate reference manpage.

 -- Shengjing Zhu <i@zhsj.me>  Wed, 27 Jun 2018 17:10:04 +0800

elvish (0.11+ds1-5) unstable; urgency=medium

  * d/control: stop using gccgo-go on ppc64el/ppc64.
    Bug in golang-go is now fixed in 1.10.

 -- Shengjing Zhu <i@zhsj.me>  Fri, 02 Mar 2018 17:29:22 +0800

elvish (0.11+ds1-4) unstable; urgency=medium

  [ Michael Stapelberg ]
  * update debian/gitlab-ci.yml (using salsa.debian.org/go-team/ci/cmd/ci)

  [ Shengjing Zhu ]
  * d/patches:
    + Add 0001-sys-Work-around-nil-references-in-Select.patch (Closes: #891822)

 -- Shengjing Zhu <i@zhsj.me>  Fri, 02 Mar 2018 11:14:48 +0800

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: elvish
 Section: shells
 Priority: optional
-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
-Uploaders: Shengjing Zhu <i@zhsj.me>,
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Uploaders: Shengjing Zhu <zhsj@debian.org>,
 Build-Depends: debhelper (>= 11),
                dh-golang,
-               gccgo-go [ppc64el ppc64],
-               golang-any [!ppc64el !ppc64],
+               golang-any,
                golang-github-boltdb-bolt-dev,
                golang-github-kr-pty-dev,
-               golang-github-xiaq-persistent-dev (>=0.0~git20180105.221501f),
+               golang-github-xiaq-persistent-dev (>=0.0~git20180301.cd415c6),
                golang-golang-x-sys-dev,
-Standards-Version: 4.1.3
+               pandoc,
+Standards-Version: 4.1.4
 Homepage: https://github.com/elves/elvish
 Vcs-Browser: https://salsa.debian.org/go-team/packages/elvish
 Vcs-Git: https://salsa.debian.org/go-team/packages/elvish.git

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

BUILDPKG   := github.com/elves/elvish/buildinfo
BUILDFLAGS := -ldflags\
  "-X $(BUILDPKG).Version=$(DEB_VERSION)"

export DH_GOLANG_EXCLUDES := website

DATE := $(shell date -u --date=@$(SOURCE_DATE_EPOCH) "+%b %d, %Y")
VER := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/+ds[0-9]*//')
PANDOC_ARG := -s -f gfm -t man -V section:7 -V header:"Miscellaneous Information Manual" -V footer:"Elvish $(VER)" -M date:"$(DATE)"

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_configure:
	# e2e_test.go needs a working terminal, it fails in my sbuild env.
	# https://github.com/elves/elvish/issues/708
	-rm -f edit/edcore/e2e_test.go
	dh_auto_configure

override_dh_auto_build:
	for file in builtin bundled edit epm language philosophy re; do \
	  pandoc $(PANDOC_ARG) -M title:"elvish-$$file" -o debian/elvish-$$file.7 website/src/ref/$$file.md; \
	done
	dh_auto_build -- $(BUILDFLAGS)

override_dh_auto_install:
	dh_auto_install -- --no-source

## elvish 0.13+ds1

=== Makefile ===
PKG_BASE := github.com/elves/elvish
PKGS := $(shell go list ./... | sed 's|^$(PKG_BASE)|.|')
PKG_COVERS := $(shell go list ./... | sed 's|^$(PKG_BASE)|.|' | grep -v '^\.$$' | sed 's/^\./cover/' | sed 's/$$/.cover/')
COVER_MODE := set
VERSION := $(shell git describe --tags --always --dirty=-dirty)

GOVERALLS := github.com/mattn/goveralls

default: test get

# TODO(xiaq): Add -trimpath when we require Go >= 1.13.
get:
	go get -ldflags "-X github.com/elves/elvish/pkg/buildinfo.Version=$(VERSION)" .

buildall:
	./tools/buildall.sh

generate:
	go generate ./...

test:
	go test $(PKGS)

cover/%.cover: %
	mkdir -p $(dir $@)
	go test -coverprofile=$@ -covermode=$(COVER_MODE) ./$<

cover/all: $(PKG_COVERS)
	echo mode: $(COVER_MODE) > $@
	for f in $(PKG_COVERS); do test -f $$f && sed 1d $$f >> $@ || true; done

upload-coverage-codecov: cover/all
	curl -s https://codecov.io/bash -o codecov.bash
	bash codecov.bash -f $<

upload-coverage-coveralls: cover/all
	go get $(GOVERALLS)
	goveralls -coverprofile $<

binaries-travis:
	./tools/binaries-travis.sh

.PHONY: default get buildall generate test testmain upload-coverage-codecov upload-coverage-coveralls binaries-travis

=== website/Makefile ===
TOOLS_DIR := ./_tools
DST_DIR = ./_dst
PUBLISH_DIR := ./_publish

MDS := home.md $(wildcard [^_]*/*.md)
HTMLS := $(MDS:.md=.html)

TOOLS := highlight macros elvdoc

default: gen

%.html: %.md $(TOOL_BINARIES) $(TOOLS_DIR)/md-to-html
	$(TOOLS_DIR)/md-to-html $< $@

%.bin: %.go
	go build -o $@ ./$<

# Generates the website into the dst directory.
gen: tools $(HTMLS) maybe-genblog
	genblog . $(DST_DIR)
	ln -sf `pwd`/_favicons/* $(DST_DIR)/

tools:
	for tool in $(TOOLS); do \
		go build -o _tools/$$tool.bin ../cmd/website/$$tool; \
	done

# Installs genblog only if not found.
maybe-genblog:
	which genblog || $(MAKE) genblog

# Installs latest genblog.
genblog:
	go get -u github.com/xiaq/genblog

# Synchronizes the generated website into $(PUBLISH_DIR). The PUBLISH_DIR
# environment variable can be overriden to a remote place to publish this online.
publish: gen
	rsync -aLv --delete ./_dst/ $(PUBLISH_DIR)/

clean:
	rm -f $(HTMLS) _tools/*.bin
	rm -rf $(DST_DIR)

.PHONY: default gen tools maybe-genblog genblog publish clean
.SECONDARY: $(TOOL_BINARIES)

=== debian/changelog ===
elvish (0.13+ds1-2ubuntu0.1) focal-security; urgency=medium

  * No-change rebuild due to golang-1.13 update

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Tue, 11 Oct 2022 00:58:08 +0200

elvish (0.13+ds1-2) unstable; urgency=medium

  * Increase test timeout to fix random failures on arm64
  * Add patch to fix panic in location and history mode

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 02 Jan 2020 23:16:43 +0800

elvish (0.13+ds1-1) unstable; urgency=medium

  * New upstream version 0.13+ds1
    + Fix crash when pressing Ctrl+n twice (Closes: #905785)
  * Update elvish.1 manpage for 0.13 release

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 02 Jan 2020 14:10:39 +0800

elvish (0.13~rc5+ds1-1) experimental; urgency=medium

  * New upstream version 0.13~rc5+ds1
  * Adapt build rules for 0.13 release
  * Update debhelper-compat to 12 with new syntax
  * Update Standards-Version to 4.4.1 (no changes)
  * Set Rules-Requires-Root to no
  * Update debian/copyright for 0.13 release

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 30 Dec 2019 23:14:48 +0800

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: elvish
 Section: shells
 Priority: optional
-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Shengjing Zhu <zhsj@debian.org>,
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                dh-golang,
                golang-any,
                golang-github-boltdb-bolt-dev,
@@ -11,8 +12,9 @@
                golang-github-xiaq-persistent-dev (>=0.0~git20180301.cd415c6),
                golang-golang-x-sys-dev,
                pandoc,
-Standards-Version: 4.1.4
+Standards-Version: 4.4.1
 Homepage: https://github.com/elves/elvish
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/go-team/packages/elvish
 Vcs-Git: https://salsa.debian.org/go-team/packages/elvish.git
 XS-Go-Import-Path: github.com/elves/elvish

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

BUILDPKG   := github.com/elves/elvish/pkg/buildinfo
BUILDFLAGS := -ldflags \
  "-X $(BUILDPKG).Version=$(DEB_VERSION)"
DATE := $(shell date -u --date=@$(SOURCE_DATE_EPOCH) "+%b %d, %Y")
VER := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/+ds[0-9]*//')
PANDOC_ARG := -s -f gfm -t man -V section:7 \
  -V header:"Miscellaneous Information Manual" \
  -V footer:"Elvish $(VER)" -M date:"$(DATE)"

export DH_GOLANG_EXCLUDES := website examples
export ELVISH_TEST_UI_TIMEOUT := 5s

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_build:
	for file in builtin bundled edit epm language name philosophy re store; do \
	  pandoc $(PANDOC_ARG) -M title:"elvish-$$file" -o debian/elvish-$$file.7 website/ref/$$file.md; \
	done
	dh_auto_build -- $(BUILDFLAGS)

override_dh_auto_install:
	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts="uversionmangle=s/(\d[\d.]*)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/, \
      dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/elves/elvish/tags \
  .*/v?(.*)\.tar\.gz

## elvish 0.14.0

=== Makefile ===
PKG_BASE := github.com/elves/elvish
PKGS := $(shell go list ./... | sed 's|^$(PKG_BASE)|.|')
PKG_COVERS := $(shell go list ./... | sed 's|^$(PKG_BASE)|.|' | grep -v '^\.$$' | sed 's/^\./cover/' | sed 's/$$/.cover/')
COVER_MODE := set
VERSION := $(shell git describe --tags --always --dirty=-dirty)

# -race requires cgo
ifneq ($(OS),Windows_NT)
    TEST_ENV := CGO_ENABLED=1
    TEST_FLAGS := -race
endif

default: test get

get:
	go get -trimpath -ldflags \
		"-X github.com/elves/elvish/pkg/buildinfo.Version=$(VERSION) \
		 -X github.com/elves/elvish/pkg/buildinfo.Reproducible=true" .

# Used by elves/up
buildall:
	./tools/buildall.sh

generate:
	go generate ./...

test:
	$(TEST_ENV) go test $(TEST_FLAGS) $(PKGS)

style:
	find . -name '*.go' | xargs goimports -w
	find . -name '*.md' | xargs prettier --tab-width 4 --prose-wrap always --write

checkstyle: checkstyle-go checkstyle-md

checkstyle-go:
	echo 'Go files that need formatting:'
	! find . -name '*.go' | xargs goimports -l \
		| sed 's/^/  /' | grep . && echo '  None!'

checkstyle-md:
	echo 'Markdown files that need formatting:'
	! find . -name '*.md' | xargs prettier --tab-width 4 --prose-wrap always -l \
		| sed 's/^/  /' | grep . && echo '  None!'

cover/%.cover: %
	mkdir -p $(dir $@)
	go test -coverprofile=$@ -covermode=$(COVER_MODE) ./$<

cover/all: $(PKG_COVERS)
	echo mode: $(COVER_MODE) > $@
	for f in $(PKG_COVERS); do test -f $$f && sed 1d $$f >> $@ || true; done

.SILENT: checkstyle-go checkstyle-md
.PHONY: default get generate test style checkstyle checkstyle-go checkstyle-md

=== website/Makefile ===
TOOLS_DIR := ./tools
DST_DIR = ./_dst
PUBLISH_DIR := ./_publish

MDS := home.md $(filter-out %/README.md,$(wildcard [^_]*/*.md))
HTMLS := $(MDS:.md=.html)

TOOLS := highlight macros elvdoc genblog

default: gen

%.html: %.md $(TOOL_BINARIES) $(TOOLS_DIR)/md-to-html
	$(TOOLS_DIR)/md-to-html $< $@

# Generates the website into the dst directory.
gen: tools $(HTMLS)
	./$(TOOLS_DIR)/genblog.bin . $(DST_DIR)
	ln -sf `pwd`/fonts.css `pwd`/favicons/* $(DST_DIR)/

tools:
	for tool in $(TOOLS); do \
		go build -o $(TOOLS_DIR)/$$tool.bin ./cmd/$$tool; \
	done

genblog:
	: # a nop, kept for backward compatibility with elves/up
	
# Synchronizes the generated website into $(PUBLISH_DIR). The PUBLISH_DIR
# environment variable can be overriden to a remote place to publish this online.
publish: gen
	rsync -aLv --delete ./_dst/ $(PUBLISH_DIR)/

clean:
	rm -f $(HTMLS) _tools/*.bin
	rm -rf $(DST_DIR)

.PHONY: default gen tools genblog publish clean
.SECONDARY: $(TOOL_BINARIES)

=== debian/changelog ===
elvish (0.14.0-2) unstable; urgency=medium

  * Fix test on slow machines
  * Update Homepage
  * Add patch to fix FTBFS with gccgo

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 11 Jul 2020 02:18:48 +0800

elvish (0.14.0-1) unstable; urgency=medium

  * New upstream version 0.14.0
  * Update Build-Depends for new version
    + Replace golang-github-boltdb-bolt-dev to
      golang-github-coreos-bbolt-dev
    + Bump golang-github-xiaq-persistent-dev to 0.0~git20190312
  * Bump debhelper-compat to 13
  * Set Reproducible to true
  * Use elvdoc to process markdown before generate manpage
  * No longer need Files-Excluded in d/copyright

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 06 Jul 2020 02:49:47 +0800

elvish (0.13.1+ds1-1) unstable; urgency=medium

  * New upstream version 0.13.1+ds1
  * Remove patch which is applied in new version
  * Update Standards-Version to 4.5.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 31 Mar 2020 00:03:52 +0800

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,18 @@
 Source: elvish
 Section: shells
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Shengjing Zhu <zhsj@debian.org>,
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
-               golang-github-boltdb-bolt-dev,
+               golang-github-coreos-bbolt-dev,
                golang-github-kr-pty-dev,
-               golang-github-xiaq-persistent-dev (>=0.0~git20180301.cd415c6),
+               golang-github-xiaq-persistent-dev (>=0.0~git20190312),
                golang-golang-x-sys-dev,
                pandoc,
-Standards-Version: 4.4.1
-Homepage: https://github.com/elves/elvish
+Standards-Version: 4.5.0
+Homepage: https://elv.sh
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/go-team/packages/elvish
 Vcs-Git: https://salsa.debian.org/go-team/packages/elvish.git

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

GOPKG := github.com/elves/elvish
GOLDFLAGS := \
	-X $(GOPKG)/pkg/buildinfo.Version=$(DEB_VERSION) \
	-X $(GOPKG)/pkg/buildinfo.Reproducible=true

export PATH := $(CURDIR)/_build/bin:$(PATH)
export ELVISH_TEST_TIME_SCALE := 20
export DH_GOLANG_EXCLUDES := website
export DEB_VERSION_UPSTREAM

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_build:
	DH_GOLANG_BUILDPKG="$(GOPKG)/website/cmd/elvdoc $(GOPKG)/cmd/withweb/elvish" \
	  DH_GOLANG_EXCLUDES="" dh_auto_build -- -ldflags "$(GOLDFLAGS)"
	./debian/genman.sh

override_dh_auto_install:
	rm -vf _build/bin/elvdoc
	dh_auto_install -- --no-source

## elvish 0.15.0

=== Makefile ===
default: test get

get:
	go get -trimpath -ldflags \
		"-X github.com/elves/elvish/pkg/buildinfo.Version=$$(git describe --tags --always --dirty=-dirty) \
		 -X github.com/elves/elvish/pkg/buildinfo.Reproducible=true" .

# Used by elves/up
buildall:
	./tools/buildall.sh

generate:
	go generate ./...

# Run unit tests -- with race detection if the platform supports it. Go's
# Windows port supports race detection, but requires GCC, so we don't enable it
# there.
test:
	if echo `go env GOOS GOARCH` | egrep -qx '(linux|freebsd|darwin) amd64'; then \
		go test -race ./... ; \
	else \
		go test ./... ; \
	fi

# Generate a basic test coverage report. This will open the report in your
# browser. See also https://codecov.io/gh/elves/elvish/.
cover:
	go test -coverprofile=cover -coverpkg=./pkg/... ./pkg/...
	go tool cover -html=cover
	go tool cover -func=cover | tail -1 | awk '{ print "Overall coverage:", $$NF }'

# Ensure the style of Go and Markdown source files is consistent.
style:
	find . -name '*.go' | xargs goimports -w
	find . -name '*.md' | xargs prettier --tab-width 4 --prose-wrap always --write

# Check if the style of the Go and Markdown files is correct without modifying
# those files.
checkstyle: checkstyle-go checkstyle-md

checkstyle-go:
	./tools/checkstyle-go.sh

checkstyle-md:
	./tools/checkstyle-md.sh

.SILENT: checkstyle-go checkstyle-md
.PHONY: default get generate test style checkstyle checkstyle-go checkstyle-md cover

=== website/Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 	: # a nop, kept for backward compatibility with elves/up
 	
 # Synchronizes the generated website into $(PUBLISH_DIR). The PUBLISH_DIR
-# environment variable can be overriden to a remote place to publish this online.
+# environment variable can be overridden to a remote place to publish this online.
 publish: gen
 	rsync -aLv --delete ./_dst/ $(PUBLISH_DIR)/

=== debian/changelog ===
elvish (0.15.0-1) unstable; urgency=medium

  * New upstream version 0.15.0
  * Not set reproducible in buildinfo.
    Debian has different reproducible definition to upstream.

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 30 Jan 2021 20:56:37 +0800

elvish (0.15.0~rc3-1) unstable; urgency=medium

  * New upstream version 0.15.0~rc3

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 26 Jan 2021 01:48:50 +0800

elvish (0.15.0~rc2-1) unstable; urgency=medium

  * New upstream version 0.15.0~rc2
  * Update Standards-Version to 4.5.1 (no changes)
  * Drop gccgo patch, applied in upstream

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 21 Jan 2021 13:33:23 +0800

elvish (0.14.1-1) unstable; urgency=medium

  * New upstream version 0.14.1

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 06 Oct 2020 02:05:22 +0800

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
                dh-golang,
                golang-any,
                golang-github-coreos-bbolt-dev,
-               golang-github-kr-pty-dev,
-               golang-github-xiaq-persistent-dev (>=0.0~git20190312),
+               golang-github-creack-pty-dev,
+               golang-github-xiaq-persistent-dev (>= 0.0~git20200820),
                golang-golang-x-sys-dev,
                pandoc,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://elv.sh
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/go-team/packages/elvish

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,7 @@
 
 GOPKG := github.com/elves/elvish
 GOLDFLAGS := \
-	-X $(GOPKG)/pkg/buildinfo.Version=$(DEB_VERSION) \
-	-X $(GOPKG)/pkg/buildinfo.Reproducible=true
+	-X $(GOPKG)/pkg/buildinfo.Version=$(DEB_VERSION)
 
 export PATH := $(CURDIR)/_build/bin:$(PATH)
 export ELVISH_TEST_TIME_SCALE := 20

## elvish 0.17.0

=== Makefile ===
ELVISH_MAKE_BIN ?= $(shell go env GOPATH)/bin/elvish
ELVISH_PLUGIN_SUPPORT ?= 0

# Treat 0 as false and everything else as true (consistent with CGO_ENABLED).
ifeq ($(ELVISH_PLUGIN_SUPPORT), 0)
    REPRODUCIBLE := true
else
    REPRODUCIBLE := false
endif

default: test get

get:
	export CGO_ENABLED=$(ELVISH_PLUGIN_SUPPORT); \
	if go env GOOS GOARCH | egrep -qx '(windows .*|linux (amd64|arm64))'; then \
		export GOFLAGS=-buildmode=pie; \
	fi; \
	mkdir -p $(shell dirname $(ELVISH_MAKE_BIN))
	go build -o $(ELVISH_MAKE_BIN) -trimpath -ldflags \
		"-X src.elv.sh/pkg/buildinfo.VersionSuffix=-dev.$$(git rev-parse HEAD)$$(git diff HEAD --quiet || printf +%s `uname -n`) \
		 -X src.elv.sh/pkg/buildinfo.Reproducible=$(REPRODUCIBLE)" ./cmd/elvish

generate:
	go generate ./...

# Run unit tests, with race detection if the platform supports it.
test:
	go test $(shell ./tools/run-race.sh) ./...
	cd website; go test $(shell ./tools/run-race.sh) ./...

# Generate a basic test coverage report, and open it in the browser. See also
# https://apps.codecov.io/gh/elves/elvish/.
cover:
	go test -coverprofile=cover -coverpkg=./pkg/... ./pkg/...
	./tools/prune-cover.sh .codecov.yml cover
	go tool cover -html=cover
	go tool cover -func=cover | tail -1 | awk '{ print "Overall coverage:", $$NF }'

# Ensure the style of Go and Markdown source files is consistent.
style:
	find . -name '*.go' | xargs goimports -w
	find . -name '*.go' | xargs gofmt -s -w
	find . -name '*.md' | xargs prettier --tab-width 4 --prose-wrap always --write

# Check if the style of the Go and Markdown files is correct without modifying
# those files.
checkstyle: checkstyle-go checkstyle-md

checkstyle-go:
	./tools/checkstyle-go.sh

checkstyle-md:
	./tools/checkstyle-md.sh

lint:
	./tools/lint.sh

codespell:
	codespell --skip .git

.SILENT: checkstyle-go checkstyle-md lint
.PHONY: default get generate test style checkstyle checkstyle-go checkstyle-md lint cover

=== website/Makefile ===
DST_DIR := ./_dst
PUBLISH_DIR := ./_publish
DOCSET_TMP_DIR := ./_docset_tmp
DOCSET_DST_DIR := ./Elvish.docset

MDS := home.md $(filter-out %/README.md,$(wildcard [^_]*/*.md))
HTMLS := $(MDS:.md=.html)

TOOL_PKGS := highlight macros elvdoc genblog
TOOL_BINS := $(addprefix tools/,$(addsuffix .bin,$(TOOL_PKGS)))

# Generates the website into $(DST_DIR).
gen: $(TOOL_BINS) $(HTMLS)
	tools/genblog.bin . $(DST_DIR)
	ln -sf `pwd`/fonts `pwd`/favicons/* $(DST_DIR)/

# Generates docset into $(DOCSET_DST_DIR).
docset: $(TOOL_BINS) $(HTMLS)
	ELVISH_DOCSET_MODE=1 tools/genblog.bin . $(DOCSET_TMP_DIR)
	./tools/mkdocset $(DOCSET_TMP_DIR) $(DOCSET_DST_DIR)

# Synchronizes the generated website into $(PUBLISH_DIR), which is passed to
# rsync and can be a remote place.
publish: gen
	rsync -aLv --delete ./_dst/ $(PUBLISH_DIR)/

check-rellinks: gen
	python3 tools/check-rellinks.py $(DST_DIR)

clean:
	rm -rf $(TOOL_BINS) $(HTMLS) $(DST_DIR) $(DOCSET_TMP_DIR) $(DOCSET_DST_DIR)

.PHONY: gen docset publish clean

.SECONDEXPANSION:

tools/%.bin: cmd/% $$(wildcard cmd/%/*.go)
	go build -o $@ ./$<

%.html: %.md $(TOOL_BINS) tools/md-to-html $$(shell tools/ref-deps $$@)
	tools/md-to-html $< $@

=== debian/changelog ===
elvish (0.17.0-1ubuntu0.1) jammy-security; urgency=medium

  * No change rebuild due to golang-1.18 update. Note that this package
    was built with golang-1.17.

 -- Allen Huang <allen.huang@canonical.com>  Mon, 18 Nov 2024 18:23:47 +0000

elvish (0.17.0-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream version 0.17.0

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 11 Dec 2021 01:55:38 +0800

elvish (0.17.0~rc4-1) experimental; urgency=medium

  * New upstream version 0.17.0~rc4
  * Add golang-github-mattn-go-isatty-dev to Build-Depends

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 08 Dec 2021 03:19:09 +0800

elvish (0.16.3-1) unstable; urgency=medium

  * New upstream version 0.16.3

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 30 Aug 2021 01:04:59 +0800

elvish (0.16.1-2) unstable; urgency=medium

  * Update Copyright
  * Update description
  * Don't add-shell on upgrade
  * Fix typos

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 24 Aug 2021 12:20:03 +0800

elvish (0.16.1-1) unstable; urgency=medium

  * New upstream version 0.16.1

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 22 Aug 2021 00:04:08 +0800

=== debian/control ===
Source: elvish
Section: shells
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Shengjing Zhu <zhsj@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-coreos-bbolt-dev,
               golang-github-creack-pty-dev,
               golang-github-mattn-go-isatty-dev,
               golang-golang-x-sys-dev,
               pandoc,
Standards-Version: 4.6.0
Homepage: https://elv.sh
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/go-team/packages/elvish
Vcs-Git: https://salsa.debian.org/go-team/packages/elvish.git
XS-Go-Import-Path: src.elv.sh
Testsuite: autopkgtest-pkg-go

Package: elvish
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Expressive programming language and versatile interactive shell
 Elvish is a cross-platform shell, supporting Linux, BSDs and Windows.
 It features an expressive programming language, with features like namespace
 and anonymous functions, and a fully programmable user interface with friendly
 defaults. It is suitable for both interactive use and scripting.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

GOPKG := src.elv.sh
VESRION_SUFFIX := +$(DEB_VENDOR)$(subst $(DEB_VERSION_EPOCH_UPSTREAM),,$(DEB_VERSION))
GOLDFLAGS := \
	-X $(GOPKG)/pkg/buildinfo.VersionSuffix=$(VESRION_SUFFIX)

export BIN_PATH := $(CURDIR)/_build/bin
export ELVISH_TEST_TIME_SCALE := 20
export DH_GOLANG_EXCLUDES := \
	cmd/examples cmd/nodaemon \
	website/cmd/genblog website/cmd/highlight website/cmd/runefreq
export DH_GOLANG_INSTALL_EXTRA := \
	pkg/mods/epm/epm.elv \
	pkg/mods/readlinebinding/readline-binding.elv \
	pkg/edit/init.elv
# DEB_VERSION_UPSTREAM is used in ./debian/genman.sh
export DEB_VERSION_UPSTREAM

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_build:
	 dh_auto_build -- -ldflags "$(GOLDFLAGS)"
	./debian/genman.sh

override_dh_auto_install:
	rm -vf _build/bin/elvdoc _build/bin/macros
	dh_auto_install -- --no-source

## elvish 0.18.0

=== debian/changelog ===
elvish (0.18.0-1ubuntu0.22.10.1) kinetic-security; urgency=medium

  * No change build due to golang-1.18 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 03 May 2023 17:24:23 +0530

elvish (0.18.0-1) unstable; urgency=medium

  * New upstream version 0.18.0
  * Add missing Build-Depends for new version
    + golang-github-google-go-cmp-dev
    + golang-github-sourcegraph-go-lsp-dev
    + golang-github-sourcegraph-jsonrpc2-dev

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 13 Apr 2022 03:13:31 +0800

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,10 @@
                golang-any,
                golang-github-coreos-bbolt-dev,
                golang-github-creack-pty-dev,
+               golang-github-google-go-cmp-dev,
                golang-github-mattn-go-isatty-dev,
+               golang-github-sourcegraph-go-lsp-dev,
+               golang-github-sourcegraph-jsonrpc2-dev,
                golang-golang-x-sys-dev,
                pandoc,
 Standards-Version: 4.6.0

=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,8 @@
 export BIN_PATH := $(CURDIR)/_build/bin
 export ELVISH_TEST_TIME_SCALE := 20
 export DH_GOLANG_EXCLUDES := \
-	cmd/examples cmd/nodaemon \
-	website/cmd/genblog website/cmd/highlight website/cmd/runefreq
+	cmd/examples cmd/nodaemon cmd/withpprof \
+	website/cmd/gensite website/cmd/highlight website/cmd/runefreq
 export DH_GOLANG_INSTALL_EXTRA := \
 	pkg/mods/epm/epm.elv \
 	pkg/mods/readlinebinding/readline-binding.elv \

## elvish 0.19.2

=== Makefile ===
ELVISH_MAKE_BIN ?= $(or $(GOBIN),$(shell go env GOPATH)/bin)/elvish$(shell go env GOEXE)
ELVISH_MAKE_BIN := $(subst \,/,$(ELVISH_MAKE_BIN))
ELVISH_MAKE_PKG ?= ./cmd/elvish

default: test most-checks get

# This target emulates the behavior of "go install ./cmd/elvish", except that
# the build output and the main package to build can be overridden with
# environment variables.
get:
	mkdir -p $(shell dirname $(ELVISH_MAKE_BIN))
	go build -o $(ELVISH_MAKE_BIN) $(ELVISH_MAKE_PKG)

# Run formatters on Go and Markdown files.
fmt:
	find . -name '*.go' | xargs goimports -w
	find . -name '*.go' | xargs gofmt -s -w
	find . -name '*.md' | xargs go run src.elv.sh/cmd/elvmdfmt -w -width 80

# Run unit tests, with race detection if the platform supports it.
test:
	go test $(shell ./tools/run-race.sh) ./...
	cd website; go test $(shell ./tools/run-race.sh) ./...

# Generate a basic test coverage report, and open it in the browser. The report
# is an approximation of https://app.codecov.io/gh/elves/elvish/.
cover:
	go test -coverprofile=cover -coverpkg=./pkg/... ./pkg/...
	./tools/prune-cover.sh .codecov.yml cover
	go tool cover -html=cover
	go tool cover -func=cover | tail -1 | awk '{ print "Overall coverage:", $$NF }'

# All the checks except check-gen.sh, which is not always convenient to run as
# it requires a clean working tree.
most-checks:
	./tools/check-fmt-go.sh
	./tools/check-fmt-md.sh
	./tools/check-disallowed.sh
	codespell
	go vet ./...
	staticcheck ./...

all-checks: most-checks
	./tools/check-gen.sh

.PHONY: default get fmt test cover most-checks all-checks

=== website/Makefile ===
DST_DIR := ./_dst
PUBLISH_DIR := ./_publish
DOCSET_TMP_DIR := ./_docset_tmp
DOCSET_DST_DIR := ./Elvish.docset

MDS := home.md $(filter-out %/README.md,$(wildcard [^_]*/*.md))
HTMLS := $(MDS:.md=.html)

# Generates the website into $(DST_DIR).
gen: tools/gensite.bin $(HTMLS)
	tools/gensite.bin . $(DST_DIR)
	ln -sf `pwd`/fonts `pwd`/favicons/* $(DST_DIR)/

# Generates docset into $(DOCSET_DST_DIR).
docset: tools/gensite.bin $(HTMLS)
	ELVISH_DOCSET_MODE=1 tools/gensite.bin . $(DOCSET_TMP_DIR)
	tools/mkdocset $(DOCSET_TMP_DIR) $(DOCSET_DST_DIR)

# Synchronizes the generated website into $(PUBLISH_DIR), which is passed to
# rsync and can be a remote place.
publish: gen
	rsync -aLv --delete ./_dst/ $(PUBLISH_DIR)/

check-rellinks: gen
	python3 tools/check-rellinks.py $(DST_DIR)

clean:
	rm -rf tools/*.bin $(HTMLS) $(DST_DIR) $(DOCSET_TMP_DIR) $(DOCSET_DST_DIR)

ifdef TTYSHOT
%.ttyshot.html: %.ttyshot tools/ttyshot.bin
	tools/ttyshot.bin $(if $(findstring verbose,$(TTYSHOT)),-v,) -o $@ $<
else
%.ttyshot.html:
	@: ttyshot generation disabled by default
endif

.PHONY: gen docset publish check-rellinks clean

# Don't remove intermediate targets
.SECONDARY:

.SECONDEXPANSION:

tools/%.bin: cmd/% $$(wildcard cmd/%/*) go.mod ../go.mod $$(shell tools/cmd-deps ./cmd/%)
	go build -o $@ ./$<

%.html: %.md tools/md2html.bin $$(shell tools/md-deps $$@)
	tools/md2html.bin < $< > $@

=== debian/changelog ===
elvish (0.19.2-1) unstable; urgency=medium

  * New upstream version 0.19.2

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 18 Mar 2023 22:25:19 +0800

elvish (0.18.0-4) unstable; urgency=medium

  * Replace add-shell/remove-shell with declarative shells.d trigger
  * Update Standards-Version to 4.6.2 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 01 Jan 2023 01:09:08 +0800

elvish (0.18.0-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository, Security-Contact.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 24 Nov 2022 17:54:24 +0000

elvish (0.18.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 21 Nov 2022 00:21:30 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: elvish
 Section: shells
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Shengjing Zhu <zhsj@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
@@ -14,8 +13,8 @@
                golang-github-sourcegraph-go-lsp-dev,
                golang-github-sourcegraph-jsonrpc2-dev,
                golang-golang-x-sys-dev,
-               pandoc,
-Standards-Version: 4.6.0
+               procps <!nocheck>,
+Standards-Version: 4.6.2
 Homepage: https://elv.sh
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/go-team/packages/elvish
@@ -26,7 +25,8 @@
 Package: elvish
 Architecture: any
 Built-Using: ${misc:Built-Using},
-Depends: ${misc:Depends},
+Depends: debianutils (>= 5.6-0.1),
+         ${misc:Depends},
          ${shlibs:Depends},
 Description: Expressive programming language and versatile interactive shell
  Elvish is a cross-platform shell, supporting Linux, BSDs and Windows.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

VESRION_SUFFIX := $(DEB_VENDOR)$(subst $(DEB_VERSION_EPOCH_UPSTREAM),,$(DEB_VERSION))
GOLDFLAGS := -X src.elv.sh/pkg/buildinfo.BuildVariant=$(VESRION_SUFFIX)

export ELVISH_TEST_TIME_SCALE := 20
export DH_GOLANG_EXCLUDES := \
	$(filter-out cmd/elvish,$(wildcard cmd/*)) \
	website examples \
	pkg/md/mdrun
export DH_GOLANG_INSTALL_EXTRA := \
	$(wildcard */*/*.elv */*/*/*.elv) \
	pkg/md/spec/spec.json

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_build:
	 dh_auto_build -- -ldflags "$(GOLDFLAGS)"

override_dh_auto_install:
	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%, \
      uversionmangle=s/-rc/~rc/" \
  https://github.com/elves/elvish/tags \
  .*/v?(\d+(?:\.\d+)+(?:-rc\d+)?)\.tar\.gz debian
